# nas-configs

Contains configuration files, e.g. docker for Synology NAS

## Deployment approach

Copy files to `\\Swaghausen-WG\admin_data\nextcloud`

## Nextcloud

Workflow:
  - copy docker-compose file to `\\Swaghausen-WG\admin_data\nextcloud`, e.g. via SFTP
  - in DSM: open Container Manager and build nextcloud project (will apply updates to compose file in production)

logs at: /volume/docker/nextcloud/data/nextcloud.log

### How to Upgrade
 - update version number in Docker Compose file at `\\Swaghausen-WG\admin_data\nextcloud`
 - open DSM. In Container Manager 
   - Download new image
   - Project -> Nextcloud -> Stop
   - Project -> Nextcloud -> Build

### Adding Redis to Nextcloud

As per [official nextcloud doc](https://docs.nextcloud.com/server/latest/admin_manual/configuration_server/caching_configuration.html#recommendations-based-on-type-of-deployment) recommendation the following has to be configuered in the `config.php` (`volume2/docker/nextcloud/config/config.php`)

```php
  'memcache.local' => '\\OC\\Memcache\\APCu',
  'memcache.distributed' => '\OC\Memcache\Redis',
  'memcache.locking' => '\OC\Memcache\Redis',
  'redis' => [
      'host' => '192.168.178.55',
     'port' => 6379,
     'password' => 'redispass1234'
  ],
```

**Other Resources**
https://intux.de/2023/07/14/memory-caching-mit-redis-fuer-nextcloud-27/
https://docs.nextcloud.com/server/latest/admin_manual/configuration_server/caching_configuration.html#organizations-with-single-server
https://help.nextcloud.com/t/installing-redis-for-memcache/162599/3


## Joplin Server
https://github.com/laurent22/joplin/issues/9499

https://github.com/laurent22/joplin/tree/dev/packages/server


open http://localhost:22300/joplin
http://192.168.178.128:22300/admin


server {
    listen 80;
    server_name joplin.swaghausen.de;
    return 301 https://joplin.swaghausen.de$request_uri;
}

server {
  listen 443 ssl;
  server_name joplin.swaghausen.de;
  ssl_certificate /usr/syno/etc/certificate/_archive/D9n1az/fullchain.pem;
  ssl_certificate_key /usr/syno/etc/certificate/_archive/D9n1az/privkey.pem;
  location / {
    proxy_pass http://localhost:22300;
  }
}

sudo nano /etc/nginx/sites-enabled/git.swaghausen.de.conf
`sudo nginx -s reload`


joplin.swaghausen.de


server {
    listen 80;
    server_name collabora.swaghausen.de;
    return 301 https://collabora.swaghausen.de$request_uri;
}

server {
  listen 443 ssl;
  server_name collabora.swaghausen.de;
  ssl_certificate /usr/syno/etc/certificate/_archive/D9n1az/fullchain.pem;
  ssl_certificate_key /usr/syno/etc/certificate/_archive/D9n1az/privkey.pem;
  location / {
    proxy_pass http://localhost:9980;
  }
}

Test: curl -k https://collabora.swaghausen.de/hosting/discovery

curl -k http://192.168.178.55:9980/hosting/capabilities
curl -k http://localhost:9980/hosting/capabilities
curl -k http://127.0.0.1:9980/hosting/capabilities
curl -k https://collabora.swaghausen.de/hosting/capabilities

/etc/nginx/sites-enabled

sudo nano tagebuch.swaghausen.de.conf

scp tagebuch.swaghausen.de.conf admin@192.168.178.55:/etc/nginx/sites-enabled/tagebuch.swaghausen.de.conf

/var/log/coolwsd.log


```
server {
  listen 443 ssl;
  server_name joplin.swaghausen.de;
  ssl_certificate /usr/syno/etc/certificate/_archive/D9n1az/fullchain.pem;
  ssl_certificate_key /usr/syno/etc/certificate/_archive/D9n1az/privkey.pem;
  proxy_set_header X-Forwarded-Host $host;
  proxy_set_header Host $host;
  proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
  proxy_set_header X-Forwarded-Proto $scheme;
  proxy_set_header X-Real-IP $remote_addr;
  location / {
    proxy_redirect off;
    proxy_pass http://127.0.0.1:22300;
  }
}
```

`sudo nginx -s reload`

test: `curl https://joplin.swaghausen.de/api/ping`
```